/*
 * Sixth 3D engine. Author: Svjatoslav Agejenko. 
 * This project is released under Creative Commons Zero (CC0) license.
 */
package eu.svjatoslav.sixth.e3d.renderer.raster.shapes.composite.wireframe;

import eu.svjatoslav.sixth.e3d.geometry.Point3D;
import eu.svjatoslav.sixth.e3d.renderer.raster.shapes.basic.line.Line;
import eu.svjatoslav.sixth.e3d.renderer.raster.shapes.basic.line.LineAppearance;
import eu.svjatoslav.sixth.e3d.renderer.raster.shapes.composite.base.AbstractCompositeShape;

public class WireframeDrawing extends AbstractCompositeShape {

    final private LineAppearance lineAppearance;
    Point3D currentPoint;

    public WireframeDrawing(final LineAppearance lineAppearance) {
        super();
        this.lineAppearance = lineAppearance;
    }

    public void addPoint(final Point3D point3d) {
        if (currentPoint != null) {
            final Line line = lineAppearance.getLine(currentPoint, point3d);
            addShape(line);
        }

        currentPoint = new Point3D(point3d);
    }

}
